// pages/bind/index.js
import util from '../../utils/util'
import http from '../../utils/http'
import api from '../../utils/api'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    projects: [],
    projectIndex: -1,
    roles: [],
    roleIndex: -1,
    name: '',
    remark: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  onInputChange: function(e) {
    var name = e.currentTarget.dataset.name
    var val = e.detail.value
    this.setData({
      [name]: val
    })
  },

  getUserInfo: function(e) {
    var that = this;
    util.wechatLogin(e, false, function(res) {
      that.submit()
    }, true)
  },

  submit: function() {
    if(!this.data.name) {
      util.error('真实姓名必填')
      return false;
    }
    if(!this.data.projectIndex < 0) {
      util.error('所属项目必填')
      return false;
    }
    if(!this.data.roleIndex < 0) {
      util.error('申请角色不能为空')
      return false;
    }
    if(this.data.remark.length < 10) {
      util.error('备注需10个字以上')
      return false;
    }
    var project = this.data.projects[this.data.projectIndex]
    var role = this.data.roles[this.data.roleIndex]
    http({
      url: 'user-auth/create',
      data: {
        name: this.data.name,
        project_id: project ? project.id : '',
        project_role_id: role ? role.id : '',
        remark: this.data.remark
      },
      success: function(res) {
        util.success('操作成功')
      }
    })
  },

  bindPickerChange: function(e) {
    var name = e.currentTarget.dataset.name
    this.setData({
      [name]: e.detail.value
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    api.getByName(this, 'projects/getAll', 'projects')
    api.getByName(this, 'project-roles/getAll', 'roles', {'limit': true})
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})